glibmm: Gio::DBus::ObjectManager Class Reference

glibmm 2.62.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::DBus::ObjectManager Class Reference
D-Bus API

Base type for D-Bus object managers. More...

`#include <giomm/dbusobjectmanager.h>`

Inheritance diagram for Gio::DBus::ObjectManager:
[legend]

## Public Member Functions
| ObjectManager (ObjectManager&& src) noexcept
ObjectManager& | operator= (ObjectManager&& src) noexcept
| ~ObjectManager () noexcept override
GDBusObjectManager* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusObjectManager* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_object_path () const
| Gets the object path that manager is for. More...
std::vector< Glib::RefPtr< Gio::DBus::Object > > | get_objects ()
| Gets all DBusObject objects known to manager. More...
std::vector< Glib::RefPtr< const Gio::DBus::Object > > | get_objects () const
| Gets all DBusObject objects known to manager. More...
Glib::RefPtr< Gio::DBus::Object > | get_object (const Glib::ustring& object_path)
| Gets the DBusObjectProxy at object_path, if any. More...
Glib::RefPtr< const Gio::DBus::Object > | get_object (const Glib::ustring& object_path) const
| Gets the DBusObjectProxy at object_path, if any. More...
Glib::RefPtr< Gio::DBus::Interface > | get_interface (const Glib::ustring& object_path, const Glib::ustring& interface_name)
| Gets the interface proxy for interface_name at object_path, if any. More...
Glib::RefPtr< const Gio::DBus::Interface > | get_interface (const Glib::ustring& object_path, const Glib::ustring& interface_name) const
| Gets the interface proxy for interface_name at object_path, if any. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Object >& > | signal_object_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Object >& > | signal_object_removed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Object >&, const Glib::RefPtr< Gio::DBus::Interface >& > | signal_interface_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::DBus::Object >&, const Glib::RefPtr< Gio::DBus::Interface >& > | signal_interface_removed ()
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| ObjectManager ()
| You should derive from this class to use it. More...
virtual Glib::ustring | get_object_path_vfunc () const
virtual std::vector< Glib::RefPtr< Gio::DBus::Object > > | get_objects_vfunc () const
virtual Glib::RefPtr< Gio::DBus::Object > | get_object_vfunc (const Glib::ustring& object_path) const
virtual Glib::RefPtr< Gio::DBus::Interface > | get_interface_vfunc (const Glib::ustring& object_path, const Glib::ustring& interface_name) const
virtual void | on_object_added (const Glib::RefPtr< Gio::DBus::Object >& object)
| This is a default handler for the signal signal_object_added(). More...
virtual void | on_object_removed (const Glib::RefPtr< Gio::DBus::Object >& object)
| This is a default handler for the signal signal_object_removed(). More...
virtual void | on_interface_added (const Glib::RefPtr< Gio::DBus::Object >& object, const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_added(). More...
virtual void | on_interface_removed (const Glib::RefPtr< Gio::DBus::Object >& object, const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_removed(). More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::DBus::ObjectManager > | wrap (GDBusObjectManager* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Base type for D-Bus object managers.

The Gio::DBus::ObjectManager type is the base type for service- and client-side implementations of the standardized org.freedesktop.DBus.ObjectManager interface.

See Gio::DBus::ObjectManagerClient for the client-side implementation and Gio::DBus::ObjectManagerServer for the service-side implementation.

Since glibmm 2.62:

## Constructor & Destructor Documentation

Gio::DBus::ObjectManager::ObjectManager | ( |  | ) |
| protected

You should derive from this class to use it.

Gio::DBus::ObjectManager::ObjectManager | ( | ObjectManager&& | src | ) |
| noexcept

Gio::DBus::ObjectManager::~ObjectManager | ( |  | ) |
| overridenoexcept

## Member Function Documentation

static void Gio::DBus::ObjectManager::add_interface | ( | GType | gtype_implementer | ) |
| static

Glib::RefPtr<Gio::DBus::Interface> Gio::DBus::ObjectManager::get_interface | ( | const Glib::ustring& | object_path,
|  | const Glib::ustring& | interface_name
| ) |  |

Gets the interface proxy for interface_name at object_path, if any.

Since glibmm 2.30:

Parameters

  object_path | Object path to look up.
  interface_name | D-Bus interface name to look up.

Returns
  A DBusInterface instance or `nullptr`. Free with Glib::object_unref().

Glib::RefPtr<const Gio::DBus::Interface> Gio::DBus::ObjectManager::get_interface | ( | const Glib::ustring& | object_path,
|  | const Glib::ustring& | interface_name
| ) |  | const

Gets the interface proxy for interface_name at object_path, if any.

Since glibmm 2.30:

Parameters

  object_path | Object path to look up.
  interface_name | D-Bus interface name to look up.

Returns
  A DBusInterface instance or `nullptr`. Free with Glib::object_unref().

virtual Glib::RefPtr<Gio::DBus::Interface> Gio::DBus::ObjectManager::get_interface_vfunc | ( | const Glib::ustring& | object_path,
|  | const Glib::ustring& | interface_name
| ) |  | const
| protectedvirtual

Glib::RefPtr<Gio::DBus::Object> Gio::DBus::ObjectManager::get_object | ( | const Glib::ustring& | object_path | ) |

Gets the DBusObjectProxy at object_path, if any.

Since glibmm 2.30:

Parameters

  object_path | Object path to look up.

Returns
  A DBusObject or `nullptr`. Free with Glib::object_unref().

Glib::RefPtr<const Gio::DBus::Object> Gio::DBus::ObjectManager::get_object | ( | const Glib::ustring& | object_path | ) | const

Gets the DBusObjectProxy at object_path, if any.

Since glibmm 2.30:

Parameters

  object_path | Object path to look up.

Returns
  A DBusObject or `nullptr`. Free with Glib::object_unref().

Glib::ustring Gio::DBus::ObjectManager::get_object_path | ( |  | ) | const

Gets the object path that manager is for.

Since glibmm 2.30:

Returns
  A string owned by manager. Do not free.

virtual Glib::ustring Gio::DBus::ObjectManager::get_object_path_vfunc | ( |  | ) | const
| protectedvirtual

virtual Glib::RefPtr<Gio::DBus::Object> Gio::DBus::ObjectManager::get_object_vfunc | ( | const Glib::ustring& | object_path | ) | const
| protectedvirtual

std::vector<Glib::RefPtr<Gio::DBus::Object> > Gio::DBus::ObjectManager::get_objects | ( |  | ) |

Gets all DBusObject objects known to manager.

Since glibmm 2.30:

Returns
  A list of DBusObject objects.

std::vector<Glib::RefPtr<const Gio::DBus::Object> > Gio::DBus::ObjectManager::get_objects | ( |  | ) | const

Gets all DBusObject objects known to manager.

Since glibmm 2.30:

Returns
  A list of DBusObject objects.

virtual std::vector<Glib::RefPtr<Gio::DBus::Object> > Gio::DBus::ObjectManager::get_objects_vfunc | ( |  | ) | const
| protectedvirtual

static GType Gio::DBus::ObjectManager::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GDBusObjectManager* Gio::DBus::ObjectManager::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GDBusObjectManager* Gio::DBus::ObjectManager::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

virtual void Gio::DBus::ObjectManager::on_interface_added | ( | const Glib::RefPtr< Gio::DBus::Object >& | object,
|  | const Glib::RefPtr< Gio::DBus::Interface >& | iface
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_interface_added().

virtual void Gio::DBus::ObjectManager::on_interface_removed | ( | const Glib::RefPtr< Gio::DBus::Object >& | object,
|  | const Glib::RefPtr< Gio::DBus::Interface >& | iface
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_interface_removed().

virtual void Gio::DBus::ObjectManager::on_object_added | ( | const Glib::RefPtr< Gio::DBus::Object >& | object | ) |
| protectedvirtual

This is a default handler for the signal signal_object_added().

virtual void Gio::DBus::ObjectManager::on_object_removed | ( | const Glib::RefPtr< Gio::DBus::Object >& | object | ) |
| protectedvirtual

This is a default handler for the signal signal_object_removed().

ObjectManager& Gio::DBus::ObjectManager::operator= | ( | ObjectManager&& | src | ) |
| noexcept

Glib::SignalProxy< void,const Glib::RefPtr<Gio::DBus::Object>&,const Glib::RefPtr<Gio::DBus::Interface>& > Gio::DBus::ObjectManager::signal_interface_added | ( |  | ) |

Slot Prototype:
  `void on_my_interface_added(const Glib::RefPtr<Gio::DBus::Object>& object, const Glib::RefPtr<Gio::DBus::Interface>& iface)`

Flags: Run Last

Emitted when iface is added to object.

This signal exists purely as a convenience to avoid having to connect signals to all objects managed by manager.

Since glibmm 2.30:

Parameters

  object | The DBusObject on which an interface was added.
  iface | The DBusInterface that was added.

Glib::SignalProxy< void,const Glib::RefPtr<Gio::DBus::Object>&,const Glib::RefPtr<Gio::DBus::Interface>& > Gio::DBus::ObjectManager::signal_interface_removed | ( |  | ) |

Slot Prototype:
  `void on_my_interface_removed(const Glib::RefPtr<Gio::DBus::Object>& object, const Glib::RefPtr<Gio::DBus::Interface>& iface)`

Flags: Run Last

Emitted when iface has been removed from object.

This signal exists purely as a convenience to avoid having to connect signals to all objects managed by manager.

Since glibmm 2.30:

Parameters

  object | The DBusObject on which an interface was removed.
  iface | The DBusInterface that was removed.

Glib::SignalProxy< void,const Glib::RefPtr<Gio::DBus::Object>& > Gio::DBus::ObjectManager::signal_object_added | ( |  | ) |

Slot Prototype:
  `void on_my_object_added(const Glib::RefPtr<Gio::DBus::Object>& object)`

Flags: Run Last

Emitted when object is added to manager.

Since glibmm 2.30:

Parameters

  object | The DBusObject that was added.

Glib::SignalProxy< void,const Glib::RefPtr<Gio::DBus::Object>& > Gio::DBus::ObjectManager::signal_object_removed | ( |  | ) |

Slot Prototype:
  `void on_my_object_removed(const Glib::RefPtr<Gio::DBus::Object>& object)`

Flags: Run Last

Emitted when object is removed from manager.

Since glibmm 2.30:

Parameters

  object | The DBusObject that was removed.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DBus::ObjectManager > wrap | ( | GDBusObjectManager * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.